
// --------------------------------------------------------------------------------

void GoToReady() {
  // go to the ready state
  if (ESC) return;
//  Serial.println(F("> GoToReady()"));
  SetLedMode(2);
}

// --------------------------------------------------------------------------------

void GoToSleep() {
  // go to the powered off state, head centred
  if (ESC) return;

  SetMainTask(0); WiFiEn = false; PixyBotActive = false; PwmEn = false;
//  HeadTask = 0; HeadActive = false; HeadToRest(); HeadMoveNow();  // centre head servo
  autoRest = autoRestMax;       // no need to auto-rest from this position
//  DetCnt = 50;                  // detach PWM 1 sec after movement has stopped
}

// --------------------------------------------------------------------------------

void JoyMoveBwd() {
  // called from main loop to respond to joystick demands
  // this function drives and steers in a backwards direction
//  Serial.println("JoyMoveBwd");
  if (Drive == 0) {
    // the start of a new movement
    Drive = JoyMode; SetLedMode(23); PWM_Start = PWM_StartMax;
  }
  // ensure joystick values are in the required range
  if (JoyX < 128) {JoyXV = 127 - JoyX;} // convert -ve vector to +ve
  else {JoyXV = JoyX - 128;} // ensure JoyX = 0 - 128
  if (JoyY < 128) {JoyYV = 127 - JoyY;} // convert -ve vector to +ve
  else {JoyYV = JoyY - 128;} // ensure JoyY = 0 - 128
  JoySpd = JoyYV; if (JoyXV > JoyYV) {JoySpd = JoyXV;}
  if (Gear == 1) {JoySpd = PWM_Start + ((JoySpd *  3)/10);}  // 1st gear demand
  if (Gear == 2) {JoySpd = PWM_Start + ((JoySpd *  6)/10);}  // 2nd gear demand
  if (Gear == 3) {JoySpd = PWM_Start + ((JoySpd * 10)/10);}  // 3rd gear demand
  if (Gear == 4) {JoySpd = PWM_Start + ((JoySpd * 14)/10);}  // 4th gear demand
  if (Gear == 5) {JoySpd = PWM_Start + ((JoySpd * 18)/10);}  // 5th gear demand
  LedSpd = JoySpd;  // grab speed for LED animation
//  if (JoySpd < PWM_Start + 15) {JoySpd += Dither; DithON = true;} else {DithON = false;}

    // now apply steering
  if (JoyX < DbLLX) {
      // turning to the left in reverse
    Steer = -((JoySpd * (DbLLX - JoyX))/192);
    DriveLft = -JoySpd - Steer; DriveRht = -JoySpd + Steer;
  } else if (JoyX > DbULX) {
      // turning to the right
    Steer = ((JoySpd * (JoyX - DbULX))/192);
    DriveLft = -JoySpd - Steer; DriveRht = -JoySpd + Steer;
  } else {Steer = 0; DriveLft = -JoySpd; DriveRht = -JoySpd;}
  
  // now apply demand
  DriveLft = constrain(DriveLft,-255,-1);
  DriveRht = constrain(DriveRht,-255,-1);
//  Serial.println("MotorPWM (" + String(DriveLft) + "," + String(DriveRht) + "," + String(DriveLft) + "," + String(DriveRht) + ")");
  MotorPWM (DriveLft,DriveRht,DriveLft,DriveRht);
  if (PWM_Start > PWM_StartMin) {PWM_Start = PWM_StartMin + ((PWM_Start - PWM_StartMin)/2);}
}

// --------------------------------------------------------------------------------

void JoyMoveFwd() {
  // called from main loop to respond to joystick demands
  // this function drives and steers in a forwards direction
//  Serial.println("JoyMoveFwd");
  if (Drive == 0) {
    // the start of a new movement
    Drive = JoyMode; SetLedMode(21); PWM_Start = PWM_StartMax;
  }
  // ensure joystick values are in the required range
  if (JoyX < 128) {JoyXV = 127 - JoyX;} // convert -ve vector to +ve
  else {JoyXV = JoyX - 128;} // ensure JoyX = 0 - 128
  if (JoyY < 128) {JoyYV = 127 - JoyY;} // convert -ve vector to +ve
  else {JoyYV = JoyY - 128;} // ensure JoyY = 0 - 128
  JoySpd = JoyYV; if (JoyXV > JoyYV) {JoySpd = JoyXV;}
  if (Gear == 1) {JoySpd = PWM_Start + ((JoySpd *  3)/10);}  // 1st gear demand
  if (Gear == 2) {JoySpd = PWM_Start + ((JoySpd *  6)/10);}  // 2nd gear demand
  if (Gear == 3) {JoySpd = PWM_Start + ((JoySpd * 10)/10);}  // 3rd gear demand
  if (Gear == 4) {JoySpd = PWM_Start + ((JoySpd * 14)/10);}  // 4th gear demand
  if (Gear == 5) {JoySpd = PWM_Start + ((JoySpd * 18)/10);}  // 5th gear demand
  LedSpd = JoySpd;  // grab speed for LED animation
//  if (JoySpd < PWM_Start + 15) {JoySpd += Dither; DithON = true;} else {DithON = false;}

   // now apply steering
  if (JoyX < DbLLX) {
    // turning to the left going forward
    Steer = -((JoySpd * (DbLLX - JoyX))/192);
    DriveLft = JoySpd + Steer; DriveRht = JoySpd - Steer;
  } else if (JoyX > DbULX) {
    // turning to the right going forward
    Steer = ((JoySpd * (JoyX - DbULX))/192);
    DriveLft = JoySpd + Steer; DriveRht = JoySpd - Steer;
  } else {Steer = 0; DriveLft = JoySpd; DriveRht = JoySpd;}
  
  // now apply constraints and demand
  DriveLft = constrain(DriveLft,1,255);
  DriveRht = constrain(DriveRht,1,255);
//  Serial.println("MotorPWM (" + String(DriveLft) + "," + String(DriveRht) + "," + String(DriveLft) + "," + String(DriveRht) + ")");
  MotorPWM (DriveLft,DriveRht,DriveLft,DriveRht);
  if (PWM_Start > PWM_StartMin) {PWM_Start = PWM_StartMin + ((PWM_Start - PWM_StartMin)/2);}
}

// --------------------------------------------------------------------------------

void JoySlideLft() {
  // called from main loop to respond to joystick demands
  // this function slides in a leftwards direction
  // FL = backwards, FR = forwards, RL = forwards, RR = backwards
//  Serial.println("JoyMoveLft");
  if (Drive == 0) {
    // the start of a new movement
    Drive = JoyMode; SetLedMode(24); PWM_Start = PWM_StartMax;
  }
  // ensure joystick values are in the required range
  if (JoyX < 128) {JoyXV = 127 - JoyX;} // ensure JoyXV = 0 - 127
  else {JoyXV = JoyX - 128;}            // ensure JoyXV = 0 - 127
  if (JoyY < 128) {JoyYV = 127 - JoyY;} // ensure JoyYV = 0 - 127
  else {JoyYV = JoyY - 128;}            // ensure JoyYV = 0 - 127
  JoySpd = JoyXV; if (JoyYV > JoyXV) {JoySpd = JoyYV;}
  if (Gear == 1) {JoySpd = PWM_Start + ((JoySpd *  3)/10);}  // 1st gear demand
  if (Gear == 2) {JoySpd = PWM_Start + ((JoySpd *  6)/10);}  // 2nd gear demand
  if (Gear == 3) {JoySpd = PWM_Start + ((JoySpd * 10)/10);}  // 3rd gear demand
  if (Gear == 4) {JoySpd = PWM_Start + ((JoySpd * 14)/10);}  // 4th gear demand
  if (Gear == 5) {JoySpd = PWM_Start + ((JoySpd * 18)/10);}  // 5th gear demand
  LedSpd = JoySpd;  // grab speed for LED animation
//  if (JoySpd < PWM_Start + 15) {JoySpd += Dither; DithON = true;} else {DithON = false;}

  // no steering applied
  Steer = 0; DriveFL = -JoySpd; DriveFR = JoySpd; DriveRL = JoySpd; DriveRR = -JoySpd;
  
  // now apply demand
  DriveFL = constrain(DriveFL,-255,  0); DriveFR = constrain(DriveFR,   0,255);
  DriveRL = constrain(DriveRL,   0,255); DriveRR = constrain(DriveRR,-255,  0);
//  Serial.println("MotorPWM (" + String(DriveFL) + "," + String(DriveFR) + "," + String(DriveRL) + "," + String(DriveRR) + ")");
  MotorPWM (DriveFL,DriveFR,DriveRL,DriveRR);
  if (PWM_Start > PWM_StartMin) {PWM_Start = PWM_StartMin + ((PWM_Start - PWM_StartMin)/2);}
}

// --------------------------------------------------------------------------------

void JoySlideNE() {
  // called from main loop to respond to joystick demands
  // this function drives diagonally in a North East direction
  // FL = forwards, FR = stop, RL = stop, RR = forwards
//  Serial.println("JoyMoveRgt");
  if (Drive == 0) {
    // the start of a new movement
    Drive = JoyMode; SetLedMode(22); PWM_Start = PWM_StartMax;
  }
  // ensure joystick values are in the required range
  if (JoyX < 128) {JoyXV = 127 - JoyX;} // ensure JoyXV = 0 - 127
  else {JoyXV = JoyX - 128;}            // ensure JoyXV = 0 - 127
  if (JoyY < 128) {JoyYV = 127 - JoyY;} // ensure JoyYV = 0 - 127
  else {JoyYV = JoyY - 128;}            // ensure JoyYV = 0 - 127
  JoySpd = JoyXV; if (JoyYV > JoyXV) {JoySpd = JoyYV;}
  if (Gear == 1) {JoySpd = PWM_Start + ((JoySpd *  5)/10);}  // 1st gear demand
  if (Gear == 2) {JoySpd = PWM_Start + ((JoySpd *  8)/10);}  // 2nd gear demand
  if (Gear == 3) {JoySpd = PWM_Start + ((JoySpd * 12)/10);}  // 3rd gear demand
  if (Gear == 4) {JoySpd = PWM_Start + ((JoySpd * 15)/10);}  // 4th gear demand
  if (Gear == 5) {JoySpd = PWM_Start + ((JoySpd * 18)/10);}  // 5th gear demand
  LedSpd = JoySpd;  // grab speed for LED animation
//  if (JoySpd < PWM_Start + 15) {JoySpd += Dither; DithON = true;} else {DithON = false;}

  // no steering applied
  Steer = 0; DriveFL = JoySpd; DriveFR = 0; DriveRL = 0; DriveRR = JoySpd;
  
  // now apply demand
  DriveFL = constrain(DriveFL,0,255); DriveRR = constrain(DriveRR,0,255);
//  Serial.println("MotorPWM (" + String(DriveFL) + "," + String(DriveFR) + "," + String(DriveRL) + "," + String(DriveRR) + ")");
  MotorPWM (DriveFL,DriveFR,DriveRL,DriveRR);
  if (PWM_Start > PWM_StartMin) {PWM_Start = PWM_StartMin + ((PWM_Start - PWM_StartMin)/2);}
}

// --------------------------------------------------------------------------------

void JoySlideNW() {
  // called from main loop to respond to joystick demands
  // this function drives diagonally in a North West direction
  // FL = stop, FR = forwards, RL = forwards, RR = stop
//  Serial.println("JoySlideNW");
  if (Drive == 0) {
    // the start of a new movement
    Drive = JoyMode; SetLedMode(22); PWM_Start = PWM_StartMax;
  }
  // ensure joystick values are in the required range
  if (JoyX < 128) {JoyXV = 127 - JoyX;} // ensure JoyXV = 0 - 127
  else {JoyXV = JoyX - 128;}            // ensure JoyXV = 0 - 127
  if (JoyY < 128) {JoyYV = 127 - JoyY;} // ensure JoyYV = 0 - 127
  else {JoyYV = JoyY - 128;}            // ensure JoyYV = 0 - 127
  JoySpd = JoyXV; if (JoyYV > JoyXV) {JoySpd = JoyYV;}
  if (Gear == 1) {JoySpd = PWM_Start + ((JoySpd *  5)/10);}  // 1st gear demand
  if (Gear == 2) {JoySpd = PWM_Start + ((JoySpd *  8)/10);}  // 2nd gear demand
  if (Gear == 3) {JoySpd = PWM_Start + ((JoySpd * 12)/10);}  // 3rd gear demand
  if (Gear == 4) {JoySpd = PWM_Start + ((JoySpd * 15)/10);}  // 4th gear demand
  if (Gear == 5) {JoySpd = PWM_Start + ((JoySpd * 18)/10);}  // 5th gear demand
  LedSpd = JoySpd;  // grab speed for LED animation
//  if (JoySpd < PWM_Start + 15) {JoySpd += Dither; DithON = true;} else {DithON = false;}

  // no steering applied
  Steer = 0; DriveFL = 0; DriveFR = JoySpd; DriveRL = JoySpd; DriveRR = 0;
  
  // now apply demand
  DriveFR = constrain(DriveFR,0,255); DriveRL = constrain(DriveRL,0,255);
//  Serial.println("MotorPWM (" + String(DriveFL) + "," + String(DriveFR) + "," + String(DriveRL) + "," + String(DriveRR) + ")");
  MotorPWM (DriveFL,DriveFR,DriveRL,DriveRR);
  if (PWM_Start > PWM_StartMin) {PWM_Start = PWM_StartMin + ((PWM_Start - PWM_StartMin)/2);}
}

// --------------------------------------------------------------------------------

void JoySlideRgt() {
  // called from main loop to respond to joystick demands
  // this function slides in a rightwards direction
  // FL = forwards, FR = backwards, RL = backwards, RR = forwards
//  Serial.println("JoyMoveRgt");
  if (Drive == 0) {
    // the start of a new movement
    Drive = JoyMode; SetLedMode(22); PWM_Start = PWM_StartMax;
  }
  // ensure joystick values are in the required range
  if (JoyX < 128) {JoyXV = 127 - JoyX;} // ensure JoyXV = 0 - 127
  else {JoyXV = JoyX - 128;}            // ensure JoyXV = 0 - 127
  if (JoyY < 128) {JoyYV = 127 - JoyY;} // ensure JoyYV = 0 - 127
  else {JoyYV = JoyY - 128;}            // ensure JoyYV = 0 - 127
  JoySpd = JoyXV; if (JoyYV > JoyXV) {JoySpd = JoyYV;}
  if (Gear == 1) {JoySpd = PWM_Start + ((JoySpd *  3)/10);}  // 1st gear demand
  if (Gear == 2) {JoySpd = PWM_Start + ((JoySpd *  6)/10);}  // 2nd gear demand
  if (Gear == 3) {JoySpd = PWM_Start + ((JoySpd * 10)/10);}  // 3rd gear demand
  if (Gear == 4) {JoySpd = PWM_Start + ((JoySpd * 14)/10);}  // 4th gear demand
  if (Gear == 5) {JoySpd = PWM_Start + ((JoySpd * 18)/10);}  // 5th gear demand
  LedSpd = JoySpd;  // grab speed for LED animation
//  if (JoySpd < PWM_Start + 15) {JoySpd += Dither; DithON = true;} else {DithON = false;}

  // no steering applied
  Steer = 0; DriveFL = JoySpd; DriveFR = -JoySpd; DriveRL = -JoySpd; DriveRR = JoySpd;
  
  // now apply demand
  DriveFL = constrain(DriveFL,   0,255); DriveFR = constrain(DriveFR,-255,  0);
  DriveRL = constrain(DriveRL,-255,  0); DriveRR = constrain(DriveRR,   0,255);
//  Serial.println("MotorPWM (" + String(DriveFL) + "," + String(DriveFR) + "," + String(DriveRL) + "," + String(DriveRR) + ")");
  MotorPWM (DriveFL,DriveFR,DriveRL,DriveRR);
  if (PWM_Start > PWM_StartMin) {PWM_Start = PWM_StartMin + ((PWM_Start - PWM_StartMin)/2);}
}

// --------------------------------------------------------------------------------

void JoySlideSE() {
  // called from main loop to respond to joystick demands
  // this function drives diagonally in a South East direction
  // FL = stop, FR = backwards, RL = backwards, RR = stop
//  Serial.println("JoyMoveRgt");
  if (Drive == 0) {
    // the start of a new movement
    Drive = JoyMode; SetLedMode(22); PWM_Start = PWM_StartMax;
  }
  // ensure joystick values are in the required range
  if (JoyX < 128) {JoyXV = 127 - JoyX;} // ensure JoyXV = 0 - 127
  else {JoyXV = JoyX - 128;}            // ensure JoyXV = 0 - 127
  if (JoyY < 128) {JoyYV = 127 - JoyY;} // ensure JoyYV = 0 - 127
  else {JoyYV = JoyY - 128;}            // ensure JoyYV = 0 - 127
  JoySpd = JoyXV; if (JoyYV > JoyXV) {JoySpd = JoyYV;}
  if (Gear == 1) {JoySpd = PWM_Start + ((JoySpd *  5)/10);}  // 1st gear demand
  if (Gear == 2) {JoySpd = PWM_Start + ((JoySpd *  8)/10);}  // 2nd gear demand
  if (Gear == 3) {JoySpd = PWM_Start + ((JoySpd * 12)/10);}  // 3rd gear demand
  if (Gear == 4) {JoySpd = PWM_Start + ((JoySpd * 15)/10);}  // 4th gear demand
  if (Gear == 5) {JoySpd = PWM_Start + ((JoySpd * 18)/10);}  // 5th gear demand
  LedSpd = JoySpd;  // grab speed for LED animation
//  if (JoySpd < PWM_Start + 15) {JoySpd += Dither; DithON = true;} else {DithON = false;}

  // no steering applied
  Steer = 0; DriveFL = 0; DriveFR = -JoySpd; DriveRL = -JoySpd; DriveRR = 0;
  
  // now apply demand
  DriveFR = constrain(DriveFR,-255,0); DriveRL = constrain(DriveRL,-255,0);
//  Serial.println("MotorPWM (" + String(DriveFL) + "," + String(DriveFR) + "," + String(DriveRL) + "," + String(DriveRR) + ")");
  MotorPWM (DriveFL,DriveFR,DriveRL,DriveRR);
  if (PWM_Start > PWM_StartMin) {PWM_Start = PWM_StartMin + ((PWM_Start - PWM_StartMin)/2);}
}

// --------------------------------------------------------------------------------

void JoySlideSW() {
  // called from main loop to respond to joystick demands
  // this function drives diagonally in a South East direction
  // FL = backwards, FR = stop, RL = stop, RR = backwards
//  Serial.println("JoyMoveRgt");
  if (Drive == 0) {
    // the start of a new movement
    Drive = JoyMode; SetLedMode(22); PWM_Start = PWM_StartMax;
  }
  // ensure joystick values are in the required range
  if (JoyX < 128) {JoyXV = 127 - JoyX;} // ensure JoyXV = 0 - 127
  else {JoyXV = JoyX - 128;}            // ensure JoyXV = 0 - 127
  if (JoyY < 128) {JoyYV = 127 - JoyY;} // ensure JoyYV = 0 - 127
  else {JoyYV = JoyY - 128;}            // ensure JoyYV = 0 - 127
  JoySpd = JoyXV; if (JoyYV > JoyXV) {JoySpd = JoyYV;}
  if (Gear == 1) {JoySpd = PWM_Start + ((JoySpd *  5)/10);}  // 1st gear demand
  if (Gear == 2) {JoySpd = PWM_Start + ((JoySpd *  8)/10);}  // 2nd gear demand
  if (Gear == 3) {JoySpd = PWM_Start + ((JoySpd * 12)/10);}  // 3rd gear demand
  if (Gear == 4) {JoySpd = PWM_Start + ((JoySpd * 15)/10);}  // 4th gear demand
  if (Gear == 5) {JoySpd = PWM_Start + ((JoySpd * 18)/10);}  // 5th gear demand
  LedSpd = JoySpd;  // grab speed for LED animation
//  if (JoySpd < PWM_Start + 15) {JoySpd += Dither; DithON = true;} else {DithON = false;}

  // no steering applied
  Steer = 0; DriveFL = -JoySpd; DriveFR = 0; DriveRL = 0; DriveRR = -JoySpd;
  
  // now apply demand
  DriveFL = constrain(DriveFL,-255,0); DriveRR = constrain(DriveRR,-255,0);
//  Serial.println("MotorPWM (" + String(DriveFL) + "," + String(DriveFR) + "," + String(DriveRL) + "," + String(DriveRR) + ")");
  MotorPWM (DriveFL,DriveFR,DriveRL,DriveRR);
  if (PWM_Start > PWM_StartMin) {PWM_Start = PWM_StartMin + ((PWM_Start - PWM_StartMin)/2);}
}

// --------------------------------------------------------------------------------

void JoyTurnLft() {
  // called from main loop to respond to joystick demands
  // this function neutral turns in a leftwards direction
//  Serial.println("JoyTurnLft");
 if (Drive == 0) {
    // the start of a new movement
    Drive = JoyMode; SetLedMode(25); PWM_Start = PWM_StartMax;
  }
  // ensure joystick values are in the required range
  if (JoyX < 128) {JoyXV = 127 - JoyX;} // convert -ve vector to +ve
  else {JoyXV = JoyX - 128;} // ensure JoyX = 0 - 128
  JoySpd = JoyXV;
  if (Gear == 1) {JoySpd = PWM_Start + ((JoySpd *  3)/10);}  // 1st gear demand
  if (Gear == 2) {JoySpd = PWM_Start + ((JoySpd *  6)/10);}  // 2nd gear demand
  if (Gear == 3) {JoySpd = PWM_Start + ((JoySpd * 10)/10);}  // 3rd gear demand
  if (Gear == 4) {JoySpd = PWM_Start + ((JoySpd * 14)/10);}  // 4th gear demand
  if (Gear == 5) {JoySpd = PWM_Start + ((JoySpd * 18)/10);}  // 5th gear demand
  LedSpd = JoySpd;  // grab speed for LED animation
//  if (JoySpd < PWM_Start + 15) {JoySpd += Dither; DithON = true;} else {DithON = false;}

  // now apply steering
  Steer = -JoySpd; DriveLft = -JoySpd; DriveRht = JoySpd;
  // now apply demand
  DriveLft = constrain(DriveLft,-255,0); DriveRht = constrain(DriveRht,0,255);
//  Serial.println("MotorPWM (" + String(DriveLft) + "," + String(DriveRht) + "," + String(DriveLft) + "," + String(DriveRht) + ")");
  MotorPWM (DriveLft,DriveRht,DriveLft,DriveRht);
  if (PWM_Start > PWM_StartMin) {PWM_Start = PWM_StartMin + ((PWM_Start - PWM_StartMin)/2);}
}

// --------------------------------------------------------------------------------

void JoyTurnRgt() {
  // called from main loop to respond to joystick demands
  // this function turns in a rightwards direction
//  Serial.println("JoyTurnRgt");
 if (Drive == 0) {
    // the start of a new movement
    Drive = JoyMode; SetLedMode(26); PWM_Start = PWM_StartMax;
  }
  // ensure joystick values are in the required range
  if (JoyX < 128) {JoyXV = 127 - JoyX;} // convert -ve vector to +ve
  else {JoyXV = JoyX - 128;} // ensure JoyX = 0 - 128
  JoySpd = JoyXV;
  if (Gear == 1) {JoySpd = PWM_Start + ((JoySpd *  3)/10);}  // 1st gear demand
  if (Gear == 2) {JoySpd = PWM_Start + ((JoySpd *  6)/10);}  // 2nd gear demand
  if (Gear == 3) {JoySpd = PWM_Start + ((JoySpd * 10)/10);}  // 3rd gear demand
  if (Gear == 4) {JoySpd = PWM_Start + ((JoySpd * 14)/10);}  // 4th gear demand
  if (Gear == 5) {JoySpd = PWM_Start + ((JoySpd * 18)/10);}  // 5th gear demand
  LedSpd = JoySpd;  // grab speed for LED animation
//  if (JoySpd < PWM_Start + 15) {JoySpd += Dither; DithON = true;} else {DithON = false;}

  // now apply steering
  Steer = JoySpd; DriveLft = JoySpd; DriveRht = -JoySpd;
  // now apply demand
  DriveLft = constrain(DriveLft,   0,255); DriveRht = constrain(DriveRht,-255,  0);
//  Serial.println("MotorPWM (" + String(DriveLft) + "," + String(DriveRht) + "," + String(DriveLft) + "," + String(DriveRht) + ")");
  MotorPWM (DriveLft,DriveRht,DriveLft,DriveRht);
  if (PWM_Start > PWM_StartMin) {PWM_Start = PWM_StartMin + ((PWM_Start - PWM_StartMin)/2);}
}

// --------------------------------------------------------------------------------

void MotorToTgtCnt(int16_t zFL,int16_t zFR,int16_t zRL,int16_t zRR,int16_t zCnt) {
  // called from a Main Task to initiate motor auto-controller, which will drive
  // the motors until a specific count is reached
  MainTaskNext = MainTask; SubNext = SubTask + 1; // store the return conditions
  // now initialise MainTask_MotorAutoCnt() task
  MainTask = 99; Reset_Slots(); TgtMovCnt = zCnt;
  PWM_FLTgt = zFL; PWM_FRTgt = zFR; PWM_RLTgt = zRL; PWM_RRTgt = zRR;
  PwmEn = true;
}

// --------------------------------------------------------------------------------
