
// --------------------------------------------------------------------------------

void MainTask_Drive_Demo1() {
  // Drive demo 1 performs a limited desktop movement  
  if (SubDel > 0) {SubDel--; return;} // subtask delay function
    
//  Serial.println("ST " + String(SubTask));
  if (ESC) {ESC = false; SubTask = 98;}  // the ESCape flag has been set, so abort this task
  switch (SubTask) {
    case 0: // Initialise
      Display_Question_YN("Demo 1","Start?"); DispNOP = true; // display and lock
      sw0_Nop = true; sw1_Nop = true; // block normal switch functions
      SlotEn = true; SubRpt = 3; SubTask++; break;
    case 1: //wait for users button choice
      if (sw0State == LOW) {SubTask = 99;}  // No, so drop out of demo
      if (sw1State == LOW) {SubTask++;}     // YES, so start demo
      break;
    case 2: // wait for YES button release
      if (sw1State != LOW) {SubCnt = 5; SubTask++;}  // YES released so start count-down
      break;
    case 3: // perform count down 5 - 0
      DisplayText2S24(String(SubCnt),"Demo 1");
      SubCnt--; if (SubCnt == 0) {DispNOP = false; DispDel = 0; SubWait = -30;}
      else {SubWait = -30; SubTask--;}  // repeat this task after a pause
      if ((sw0State == LOW) || (sw1State == LOW)) {SubTask = 98; return;} // check for abort action
      break;
      
    //#########################
    // movement entry point
    //#########################
    // these tasks hand over control to an automated task to complete each movement based on slot counts
    case  4: // speed up neutral right turn
      SetLedMode(26); MotorToTgtCnt(75,-75,75,-75,273);  break;  // 273 == 180 degrees
    case  5: SubWait = -30; break; // 500ms pause
    case  6: // speed up neutral left turn
      SetLedMode(25); MotorToTgtCnt(-95,95,-95,95,546); break;  // 546 == 360 degrees
    case  7: SubWait = -30; break; // 500ms pause
    case  8: // speed up neutral right turn
      SetLedMode(26); MotorToTgtCnt(75,-75,75,-75,273); break;
    case  9: SubWait = -30; break; // 500ms pause
    case 10: // move forward
      SetLedMode(21); MotorToTgtCnt(70,70,70,70,120); break;
    case 11: SubWait = -30; break; // 500ms pause
    case 12: // move backward
      SetLedMode(23); MotorToTgtCnt(-90,-90,-90,-90,240); break;
    case 13: SubWait = -30; break; // 500ms pause
    case 14: // move forward
      SetLedMode(21); MotorToTgtCnt(70,70,70,70,120); break;
    case 15: SubWait = -30; break; // 500ms pause
    case 16: // move sideways right
      SetLedMode(22); MotorToTgtCnt(75,-75,-75,75,120); break;
    case 17: SubWait = -30; break; // 500ms pause
    case 18: // move sideways left
      SetLedMode(24); MotorToTgtCnt(-95,95,95,-95,240); break;
    case 19: SubWait = -30; break; // 500ms pause
    case 20: // move sideways right
      SetLedMode(22); MotorToTgtCnt(75,-758,-75,75,120); break;
    case 21: SubWait = -60; break; // 500ms pause
      
    case 22: // Slide NE
      SetLedMode(22); MotorToTgtCnt(85, 0, 0,85,120);  break;
    case 23: SubWait = -30; break; // 500ms pause
    case 24: // Slide SW back to centre
      SetLedMode(24); MotorToTgtCnt(-85, 0, 0,-85,120);  break;
    case 25: SubWait = -30; break; // 500ms pause
    case 26: // slide right
      SetLedMode(22); MotorToTgtCnt(85,-85,-85,85,120); break;
    case 27: SubWait = -30; break; // 500ms pause
    case 28: // slide left back to centre
      SetLedMode(24); MotorToTgtCnt(-85,85,85,-85,120); break;
    case 29: SubWait = -30; break; // 500ms pause
    case 30: // Slide SE
      SetLedMode(22); MotorToTgtCnt( 0,-85,-85, 0,120);  break;
    case 31: SubWait = -30; break; // 500ms pause
    case 32: // Slide NW back to centre
      SetLedMode(24); MotorToTgtCnt( 0,85,85, 0,120);  break;
    case 33: SubWait = -30; break; // 500ms pause
    case 34: // Drive backwards
      SetLedMode(23); MotorToTgtCnt(-75,-75,-75,-75,120);  break;
    case 35: SubWait = -30; break; // 500ms pause
    case 36: // Drive forwards back to centre
      SetLedMode(21); MotorToTgtCnt(75,75,75,75,120);  break;
    case 37: SubWait = -30; break; // 500ms pause
    case 38: // Slide SW
      SetLedMode(24); MotorToTgtCnt(-85, 0, 0,-85,120);  break;
    case 39: SubWait = -30; break; // 500ms pause
    case 40: // Slide NE back to centre
      SetLedMode(22); MotorToTgtCnt(85, 0, 0,85,120);  break;
    case 41: SubWait = -30; break; // 500ms pause
    case 42: // slide left
      SetLedMode(24); MotorToTgtCnt(-85,85,85,-85,120); break;
    case 43: SubWait = -30; break; // 500ms pause
    case 44: // slide right back to centre
      SetLedMode(22); MotorToTgtCnt(85,-85,-85,85,120); break;
    case 45: SubWait = -30; break; // 500ms pause
    case 46: // Slide NW
      SetLedMode(24); MotorToTgtCnt( 0,85,85, 0,120);  break;
    case 47: SubWait = -30; break; // 500ms pause
    case 48: // Slide SE back to centre
      SetLedMode(22); MotorToTgtCnt( 0,-85,-85, 0,120);  break;
    case 49: SubWait = -30; break; // 500ms pause
    case 50: // Drive forwards
      SetLedMode(21); MotorToTgtCnt(75,75,75,75,120);  break;
    case 51: SubWait = -30; break; // 500ms pause
    case 52: // Drive backwards
      SetLedMode(23); MotorToTgtCnt(-75,-75,-75,-75,120);  break;
    case 53: SubWait = -30; break; // 500ms pause
    
    case 54: // check for repeat
      SubRpt--; if (SubRpt > 0) {SubWait = -60;} else {SubTask = 99;} break;
    case 55: // branch to start
      SubTask = 4; break;

    case 97:  // wait loop, whilst checking switches
      if ((sw0State == LOW) || (sw1State == LOW)) {SubTask = 98;} // check for switch action
      SubWait--; if (SubWait < 1) {SubTask = SubNext;}
      break;
    case 98:  // abort countdown or movement
      DisplayText1S24("Abort"); SubTask++; break;
    case 99:  // exit point
      // Wait for both switches to be released
      if ((sw0State == HIGH) && (sw1State == HIGH)) {SetMainTask(10);}
      break;
  } if (ESC) {return;}
  // check to see if we want to pause?
  if (SubWait < 0) {SubWait = abs(SubWait); SubNext = SubTask + 1; SubTask = 97;SetLedMode(2);}
}

// --------------------------------------------------------------------------------

void MainTask_LTOF() {
  // Demonstrate LTOF ranging
  SetLedMode(5); MainTask = 0;
}

// --------------------------------------------------------------------------------

void MainTask_MotorAutoCnt() {
  // call at 60Hz to control the motors until a specific slot count is reached
  // this task must be set up correctly by MotorToTgtCnt(,,,,) to work
  // if a button is pressed then and ESCape flag is set to exist the parent task
  // the target count is the accumulation of all wheel counters, ignoring the signs
  // a button press causes the movement to end
  if ((sw0State == LOW) || (sw1State == LOW)) {ESC = true; MotorPWM (0,0,0,0); MainTask = MainTaskNext; SubTask = SubNext; return;}
  
  // start by getting the total of slot counts
  int16_t zCnt = abs(IntP34Cnt) + abs(IntP35Cnt) + abs(IntP36Cnt) + abs(IntP39Cnt);
  // check for exit condition if count is reached
  if (zCnt >= TgtMovCnt) {MotorPWM (0,0,0,0); MainTask = MainTaskNext; SubTask = SubNext; return;}
  
  // check to ensure that wheels have not stalled?
  if (!IntP34Ch && !IntP35Ch && !IntP36Ch && !IntP39Ch) {
    // none of the slot sensors have changed so increase power
    if (PWM_FLTgt > 0) {PWM_FLTgt++;} else if (PWM_FLTgt < 0) {PWM_FLTgt--;}
    PWM_FLTgt = constrain(PWM_FLTgt,-255,255);
    if (PWM_FRTgt > 0) {PWM_FRTgt++;} else if (PWM_FRTgt < 0) {PWM_FRTgt--;}
    PWM_FRTgt = constrain(PWM_FRTgt,-255,255);
    if (PWM_RLTgt > 0) {PWM_RLTgt++;} else if (PWM_RLTgt < 0) {PWM_RLTgt--;}
    PWM_RLTgt = constrain(PWM_RLTgt,-255,255);
    if (PWM_RRTgt > 0) {PWM_RRTgt++;} else if (PWM_RRTgt < 0) {PWM_RRTgt--;}
    PWM_RRTgt = constrain(PWM_RRTgt,-255,255);
  }
  // check for slow down condition
  else if ((TgtMovCnt - zCnt) <= 40) {
    // approaching target count so slow down PWMs if != 0
    if (PWM_FLTgt > 0) {PWM_FLTgt = PWM_StartMin;} else if (PWM_FLTgt < 0) {PWM_FLTgt = -PWM_StartMin;}
    if (PWM_FRTgt > 0) {PWM_FRTgt = PWM_StartMin;} else if (PWM_FRTgt < 0) {PWM_FRTgt = -PWM_StartMin;}
    if (PWM_RLTgt > 0) {PWM_RLTgt = PWM_StartMin;} else if (PWM_RLTgt < 0) {PWM_RLTgt = -PWM_StartMin;}
    if (PWM_RRTgt > 0) {PWM_RRTgt = PWM_StartMin;} else if (PWM_RRTgt < 0) {PWM_RRTgt = -PWM_StartMin;}
  }
  
  // now set target PWMs
  MotorToTgt(PWM_FLTgt,PWM_FRTgt,PWM_RLTgt,PWM_RRTgt);
  // set slot edge monitors
  IntP34Ch = false; IntP35Ch = false; IntP36Ch = false; IntP39Ch = false;
}

// --------------------------------------------------------------------------------

void MainTask_PixyFollow(int16_t zM) {
  // here we use the output of the pand and tilt code to change the orientation of
  // PixyBot2 so that its body is always pointing towards the object
  // 0 = only turn left / right
  // 1 = drive in all directions, moderate
  // 2 = drive in all directions, fast
  // object range is determined by its width, nominal range mW = 140 +/-10 DB
  // first we call pan and tilt task, which will give us the pan servo angle
  PWM_Start = PWM_StartMax;
  if (zM < 2) {
    // moderate speeds
    PwmFwdMax = 160; PwmBckMax = 80;
  } else {
    // fast speeds
    PwmFwdMax = 200; PwmBckMax = 100;
  }
  switch (SubTask1) {
    case 0: // Initialise
      R0 = 250; R1 = 230; R2 = 200; R3 = 150; R4 = 130; R5 = 80; R6 = 60; RM = 40;
      PwmInt = 0; SetLedMode(31); Drive = 0; SubTask1++; break;
    case 1: // wait for object gesture before starting
      MainTask_PixyPanTilt(1);
      if (SigId > 0) {DisplayText2S24("Ready","For  Play"); SubTask1++;}
      break;
    case 2: // wait for object to go into neutral zone
      getSigAp(); // get the array pointer for this signature
      if (SigAp >= 0) {if (Pixy_mW[SigAp] <= R3) {DisplayText2S24("GO!","Active"); SubTask1++;}}
      break;
    case 3: // ACTIVE state, wait for blocks and move
      MainTask_PixyPanTilt(1);
      getSigAp(); // get the array pointer for this signature
      // check for stop gesture?
      if (SigId < 1) {
        DisplayText2S24("STOP","Inactive"); SubTask1 = 4;
        SetLedMode(31); Drive = 0; DriveLft = 0; DriveRht = 0;  // brake
        PWM_FL = DriveLft; PWM_FR = DriveRht; PWM_RL = DriveLft; PWM_RR = DriveRht;
        return; // exit at this point, SubTask1 == 4 will resume next time
      }
      // ensure we are still tracking?
      if ((BlockCnt < 1) || (Pixy_mW[SigAp] < RM)) {
        // no object detected or lost sight of object, too small
        SetLedMode(31); DriveLft = 0; DriveRht = 0;
      } else {
        // ensure that object is at nominal range, or move towards it
        if (zM && (Pixy_mW[SigAp] <= R4)) {
          //############################################################
          // Forwards
          //############################################################
          // object under size, move towards object
          // size reduction changes less with range so apply more gain
//          Serial.println("Forwd");
          // speed up at first, but then slow down as object moves too far away
          // between object width of R4 - R5 speed up towards it, try to catch up with object
          // between object width of R5 - R6 steady speed towards object
          // between object width of R6 - RM slow down to stop, object is going out of range
          // we use a max PWM value of zPwmMax
          if (Pixy_mW[SigAp] >= RM) {
                 if (Pixy_mW[SigAp] <= R6) {DriveLft = map16(Pixy_mW[SigAp],RM,R6,PWM_StartMin,PwmFwdMax);}
            else if (Pixy_mW[SigAp] <= R5) {DriveLft = PwmFwdMax;}
            else if (Pixy_mW[SigAp] <= R4) {DriveLft = map16(Pixy_mW[SigAp],R5,R4,PwmFwdMax,PWM_StartMin);}
            else {DriveLft = 0;}  // entered centre deadband
          } else {DriveLft = 0;}  // out of range
          DriveRht = DriveLft;
          if (DriveLft > 0) {
            // moving so calculate forwards steering component
            if (servoVal[0] > (servoCtr[0] + 50)) {
              // object is to the left of the robot
  //            Serial.println("FwdLft");
              DriveTmp = map16(servoVal[0],servoCtr[0] + 50,servoMax[0],0,DriveLft);
              DriveRht += DriveTmp; DriveLft -= DriveTmp;
            } else if (servoVal[0] < (servoCtr[0] - 50)) {
              // object is to the right of the robot
  //            Serial.println("FwdRht");
              DriveTmp = map16(servoVal[0],servoMin[0],servoCtr[0] - 50,DriveLft,0);
              DriveLft += DriveTmp; DriveRht -= DriveTmp;
            }
          }
          DriveLft = constrain(DriveLft,0,PwmFwdMax);
          DriveRht = constrain(DriveRht,0,PwmFwdMax);
          // test for STOP when object is too small
          if (Pixy_mW[SigAp] < RM) {DriveLft = 0; DriveRht = 0;}
          // test for change in direction
          if (Drive < 0) {DriveLft = 0; DriveRht = 0;}
          SetLedMode(21); Drive = 1; // change LEDs and drive direction flag
        } else if (zM && (Pixy_mW[SigAp] >= R3)) {
          //############################################################
          // Backwards
          //############################################################
          // object is over size, move away from it by driving backwards
          // we use a max PWM value of zPwmRev
          // between object width of R3 - R2 speed up away from object
          // between object width of R2 - R1 steady max speed away from object
          // between object width of R1 - R0 slow down away from it, any closer stop
          // the speed tailoff makes it easier to cancel SigId assignment
          // head position applies reverse steering
//          Serial.println("Bckwd");
          if (Pixy_mW[SigAp] >= R3) {
                 if (Pixy_mW[SigAp] < R2) {DriveLft = map(Pixy_mW[SigAp],R3,R2,PWM_StartMin,PwmBckMax);}
            else if (Pixy_mW[SigAp] < R1) {DriveLft = PwmBckMax;}
            else if (Pixy_mW[SigAp] < R0) {DriveLft = map(Pixy_mW[SigAp],R1,R0,PwmBckMax,PWM_StartMin);}
            else {SubTask1 = 4; return;}  // STOP, too close!
          } else {DriveLft = 0;}
          DriveRht = DriveLft;
          if (DriveLft > 0) {
            // moving so calculate backwards steering component
            // in reverse steering component is applied to opposite wheels
            if (servoVal[0] > (servoCtr[0] + 50)) {
              // object is to the left of the robot
  //            Serial.println("BckLft");
              DriveTmp = map16(servoVal[0],servoCtr[0] + 50,servoMax[0],0,DriveLft);
              DriveLft += DriveTmp; DriveRht -= DriveTmp;
            } else if (servoVal[0] < (servoCtr[0] - 50)) {
              // object is to the right of the robot
  //            Serial.println("BckRht");
              DriveTmp = map16(servoVal[0],servoMin[0],servoCtr[0] - 50,DriveLft,0);
              DriveLft -= DriveTmp; DriveRht += DriveTmp;
            }
          }
          DriveLft = constrain(DriveLft,0,PwmBckMax);
          DriveRht = constrain(DriveRht,0,PwmBckMax);
          // reverse drive values for backwards
          DriveLft = -DriveLft; DriveRht = -DriveRht;
          // test for change in direction
          if (Drive > 0) {DriveLft = 0; DriveRht = 0;}
          SetLedMode(23); Drive = -1; // change LEDs and drive direction flag
        } else if (zM == 0) {
          //############################################################
          // Turn Left/Right
          //############################################################
          // object is within desired range band
          // now use the pan servo value to turn and point towards the object
          if (servoVal[0] > (servoCtr[0] + 25)) {
            // object is to the left of the robot, so turn left
//            Serial.println("LftTrn");
            // P gain is determined by PWM_StartMax and zPwmRev value range
            DriveRht = map16(servoVal[0],servoCtr[0] + 50,servoMax[0],PWM_StartMin,PwmFwdMax);
//            // increase right I gain factor, but limit its contribution
//            if (PwmInt < PWM_StartMax) {PwmInt++;}  // bottom end integrator
//            DriveRht += ((PwmInt * JX)/51);  // P + I gains
            DriveRht = constrain(DriveRht,0,PwmFwdMax);
            DriveLft = -DriveRht; SetLedMode(25); Drive = 3;
          } else if (servoVal[0] < (servoCtr[0] - 25)) {
            // object is to the right of the robot
//            Serial.println("RhtTrn");
            // P gain is determined by PWM_StartMax and zPwmRev value range
            DriveLft = map16(servoVal[0],servoMin[0],servoCtr[0] - 50,PwmFwdMax,PWM_StartMin);
//            // increase left I gain factor, but limit its contribution
//            if (PwmInt < PWM_StartMax) {PwmInt++;}  // bottom end integrator
//            DriveLft += ((PwmInt * JX)/51);  // P + I gains
            DriveLft = constrain(DriveLft,0,PwmFwdMax);
            DriveRht = -DriveLft; SetLedMode(26); Drive = 2;
          } else {
            // object is in centre so turn off drive
//            Serial.println("Stop");
            DriveLft = 0; DriveRht = 0; SetLedMode(31); Drive = 0;
            PwmInt = 0;
          }
        } else {
            // no demand required
            DriveLft = 0; DriveRht = 0; SetLedMode(31); Drive = 0;
            PwmInt = 0;
        }
      }
      // now apply drive signals via the target function, to soften the response
      PWM_FL = DriveLft; PWM_FR = DriveRht; PWM_RL = DriveLft; PWM_RR = DriveRht;
//      MotorToTgt(DriveLft,DriveRht,DriveLft,DriveRht);
      break;
    case 4: // dropping out of Play mode
      // wait for width == neutral state
      MainTask_PixyPanTilt(1);
      // ensure motors are off
      PWM_FL = 0; PWM_FR = 0; PWM_RL = 0; PWM_RR = 0;
      // check for safe gesture
      if (Pixy_mW[0] <= R3) {DisplayText2S24("SAFE","Waiting"); SubTask1 = 1;}
      break;
  }
}

// --------------------------------------------------------------------------------

void MainTask_PixyGoalie() {
  // here we use the output of the pan and tilt code to change the position of
  // PixyBot2 so that its body is always opposite the object
  // object range is determined by its width, nominal range mW = 140 +/-10 DB
  // first we call pan and tilt task, which will give us the pan servo angle
  switch (SubTask1) {
    case 0: // Initialise
      R0 = 250; R1 = 230; R2 = 200; R3 = 150; R4 = 130; R5 = 80; R6 = 60; RM = 40;
      PWM_Start = PWM_StartMax; PwmFwdMax = 180; PwmBckMax = 80;
      SetLedMode(31); Drive = 0; SubTask1++; break;
    case 1: // wait for object gesture before starting
      MainTask_PixyPanTilt(1);
      if (SigId > 0) {DisplayText2S24("Ready","For  Play"); SubTask1++;}
      break;
    case 2: // wait for object to go into neutral zone
      getSigAp(); // get the array pointer for this signature
      if (SigAp >= 0) {if (Pixy_mW[SigAp] <= R3) {DisplayText2S24("GO!","Active"); SubTask1++;}}
      break;
    case 3: // ACTIVE state, wait for blocks and move
      MainTask_PixyPanTilt(1);
      getSigAp(); // get the array pointer for this signature
      // check for stop gesture?
      if (SigId < 1) {
        DisplayText2S24("STOP","Inactive"); SubTask1 = 4;
        SetLedMode(31); Drive = 0; DriveLft = 0; DriveRht = 0;  // brake
        PWM_FL = DriveLft; PWM_FR = DriveRht; PWM_RL = DriveLft; PWM_RR = DriveRht;
        return; // exit at this point, SubTask1 == 4 will resume next time
      }
      // ensure we are still tracking?
      if ((BlockCnt < 1) || (Pixy_mW[SigAp] < RM)) {
        // no object detected or lost sight of object, too small
        SetLedMode(31); DriveLft = 0; DriveRht = 0;
        PWM_FL = 0; PWM_FR = 0; PWM_RL = 0; PWM_RR = 0;
      } else {
        //############################################################
        // Slide Left/Right
        //############################################################
        // object is within desired range band
        // now use the pan servo value to slide opposite the object
        if (servoVal[0] > (servoCtr[0] + 25)) {
          // object is to the left of the robot, so slide left
//            Serial.println("SlideLft");
          // P gain is determined by PWM_StartMin and PwmFwdMax value range
          DriveLft = map16(servoVal[0],servoCtr[0] + 50,servoMax[0],PWM_StartMin,PwmFwdMax);
          DriveLft = constrain(DriveLft,0,PwmFwdMax);
          PWM_FL = -DriveLft; PWM_FR = DriveLft; PWM_RL = DriveLft; PWM_RR = -DriveLft;
          SetLedMode(25); Drive = 3;
        } else if (servoVal[0] < (servoCtr[0] - 25)) {
          // object is to the right of the robot, so slide right
//            Serial.println("SlideRht");
          // P gain is determined by PWM_StartMin and PwmFwdMax value range
          DriveRht = map16(servoVal[0],servoMin[0],servoCtr[0] - 50,PwmFwdMax,PWM_StartMin);
          DriveRht = constrain(DriveRht,0,PwmFwdMax);
          PWM_FL = DriveRht; PWM_FR = -DriveRht; PWM_RL = -DriveRht; PWM_RR = DriveRht;
          SetLedMode(26); Drive = 2;
        } else {
          // object is in centre so turn off drive
//            Serial.println("Stop");
          DriveLft = 0; DriveRht = 0; SetLedMode(31); Drive = 0;
          PWM_FL = 0; PWM_FR = 0; PWM_RL = 0; PWM_RR = 0;
        }
      }
      break;
    case 4: // dropping out of Play mode
      // wait for width == neutral state
      MainTask_PixyPanTilt(1);
      // ensure motors are off
      PWM_FL = 0; PWM_FR = 0; PWM_RL = 0; PWM_RR = 0;
      // check for safe gesture
      if (Pixy_mW[0] <= R3) {DisplayText2S24("SAFE","Waiting"); SubTask1 = 1;}
      break;
  }
}

// --------------------------------------------------------------------------------

void MainTask_PixyPanTilt(int16_t zM) {
  // demonstrates Pixy2 camera in CCC tracking mode
  // zM == 0  - called as a primary task
  // zM == 1  - called from a primary task as a sub function
  // Pixy2 servo assignment:
  // [0] - Pixy2 Pan servo, increase turns left, decrease turns right
  // [1] - Pixy2 Tilt servo, increase lean forward, decrease leans back
  // camera view W x H = 316 x 208
  bool zC = false;  // autocentre flag
  int16_t zP = 0;   // array pointer
  // if a signature has been assigned look for it in the array
  if ((SigId > 0) && (BlockCnt > 0)) {
    zC = true;  // set no match for auto-centre Pan/Tilt
    for (int zA = 0;zA < BlockCnt;zA++) {
     if (Pixy_Sg[zA] == SigId) {zP = zA; zC = false; break;}  // found a signature
    }
  }
  // look for signature assignment/cencellation
  switch (SigTask) {
    case 0: // not yet in signature mode, so check to see if size is big enough to trigger it
      if (Pixy_mW[0] >= SigHi) {
        SigId = Pixy_Sg[0]; SigTask = 1;
        if (zM == 0) {DisplayText2S24("SigId",String(SigId));}
      } break;
    case 1: // waiting for object to move away, to consolidate signature
      if (Pixy_mW[zP] <= SigLo) {SigTask = 2;}
      break;
    case 2: // in signature mode, so check to see if size is big enough to cancel it
      if (Pixy_mW[zP] >= SigHi) {
        SigId = 0; SigTask = 3; SubTask = 1;
        if (zM == 0) {DisplayText2S24("SigId","---");}
      } break;
    default: // waiting for object to move away, to confirm cancelled signature
      // also increment SigTask to act as a 1 sec delay counter
      SigTask++; if ((Pixy_mW[zP] <= SigLo) && (SigTask > 60)) {SigTask = 0;}
      break;
  }
//  Serial.println(String(SigId) + "," + String(SigTask));
  switch (SubTask) {
    case 0: // Initialise
      SetLedMode(31); servoInt[0] = 0; servoInt[1] = 0;
      SubTask++; break;
    case 1: // wait for signature assignment, and valid blocks, or centre head
      if (!zC && (SigTask == 2) && (BlockCnt > 0) && (Pixy_mW[zP] >= 20)) {SubTask++;}
      else {
        // auto-centre if nothing to follow
        // this slowly moves the camera back to the centre X,Y positions
        if (servoVal[0] > servoCtr[0]) {
          if (servoVal[0] > (servoCtr[0] + 4)) {servoVal[0]-= 4;} else {servoVal[0] = servoCtr[0];}
          zC = true;}
        else if (servoVal[0] < servoCtr[0]) {
          if (servoVal[0] < (servoCtr[0] - 4)) {servoVal[0]+= 4;} else {servoVal[0] = servoCtr[0];}
          zC = true;}
        if (servoVal[1] > servoCtr[1]) {
          if (servoVal[1] > (servoCtr[1] + 4)) {servoVal[1]-= 4;} else {servoVal[1] = servoCtr[1];}
          zC = true;}
        else if (servoVal[1] < servoCtr[1]) {
          if (servoVal[1] < (servoCtr[1] - 4)) {servoVal[1]+= 4;} else {servoVal[1] = servoCtr[1];}
          zC = true;}
        if (zC) {pixy.setServos(servoVal[0],servoVal[1]);}
      } break;
    case 2: // track blocks
      if (BlockCnt > 0) {
        // block(s) detected
        // we apply a deadband to the controllers response
        // display centre is CX = 158, CY = 104
        // for stability & noise rejection deadbands are CX +/- 6 and CY +/- 4
        DispCX = Pixy_mX[zP];
//        Serial.println(DispCX);
        if (DispCX > PxDbUL) {
          // block is to the right of view centre
          servoVal[0] -= (DispCX - PxDbUL)/3; // pan P gain
//          servoVal[0] -= (DispCX - PxDbUL)*JX/255; // P gain
        } else {
          // block is to the left of view centre
          servoVal[0] += (PxDbLL - DispCX)/3;  // pan P gain
//          servoVal[0] += (PxDbLL - DispCX)*JX/255;  // P gain
        }
        servoVal[0] = constrain(servoVal[0],servoMin[0],servoMax[0]);

        DispCY = Pixy_mY[zP];
        if (DispCY > PyDbUL) {
          // block is below view centre
          servoVal[1] += (DispCY - PyDbUL)*32/64; // tilt P gain
//          servoVal[1] += (DispCY - PyDbUL)*JX/255; // P gain
        } else if (DispCY < PyDbLL) {
          // block is above view centre
          servoVal[1] -= (PyDbLL - DispCY)*32/64; // tilt P gain
//          servoVal[1] -= (PyDbLL - DispCY)*JX/255; // P gain
        }
        servoVal[1] = constrain(servoVal[1],servoMin[1],servoMax[1]);
        // now apply values to servos
        pixy.setServos(servoVal[0],servoVal[1]);
//          Serial.println(String(DispCX) + "," + String(DispCY) + "," + String(servoVal[0]) + "," + String(servoVal[1]));
     } else {SubTask = 1;} // no more blocks!
      break;
  }
//  Serial.println(String(DispCX) + "," + String(DispCY));
}

// --------------------------------------------------------------------------------

void MainTask_PixyStatic() {
  // demonstrates Pixy2 camera in static colour connected mode  
  SetLedMode(31); MainTask = 0;
}

// --------------------------------------------------------------------------------

void MainTask_Set_Camera() {
  // camera settings task
  switch (SubTask) {
    case 0: // initialisation camera lux adjustment mode
      DispMode = 41; DispVal = CamerLux;
      SubTask++; break;
    case 1: // waiting task, whilst buttons are pressed
      // a button press resets the time-out
      if ((sw0LastState == LOW) || (sw1LastState == LOW)) {SubCnt = 0;}
      break;
    case 2: // adjust camera and exit
      CamerLux = DispVal; pixy.setCameraBrightness(CamerLux);
      SetMainMode(0); break;
  }
  // 3 second time-out
  SubCnt++; if (SubCnt > 180) {SubTask = 2;}  // task time-out
}

// --------------------------------------------------------------------------------

void MainTask_TrackWall(int zMode) {
  // LTOF demo, dual function depending on zMode value
  // zMode = 0 backs away from an approaching target
  // zMode = 1 maintains a fixed distance from a wall, stays in this mode until reset
  // refer to Calibration document for ranging diagrams and limits
  if (MainRun) {return;}
  
  MainRun = true; // prevent re-entry of task
  switch (SubTask) {
    case 0: // initialise, set range limits and LED mode
      // R0 - minimum range, stopping point
      // RM - max range, object detected
      Status$ = "Initialising";
      R0 = 55; RM = 335; Drive = 0; SetLedMode(5);
      DrivePWM = PWM_StartMax; PWM_Start = PWM_StartMin; Slots_ON();
      PwmFwdMax = 140; PwmBckMax = 100;
      if (zMode == 0) {
//        Serial.println(F("> MainTask_BackAway()"));
        // R1 - range below which we slow down
        // R2 - range which detemines max backaway speed
        // R3 - range as which we start to backaway
        R1 = 124; R2 = 180; R3 = 325;
      } else {
//        Serial.println(F("> MainTask_TrackWall()"));
        // R1 - range below which we slow down
        // R2 - range which detemines max backaway speed
        // R3 - range as which we start to backaway
        // R4 - range at which we stop going forward
        // R5 - range at which we reach max speed going forward
        // R6 - range at which we start going forward or slow as we lose the target
        R1 = 90; R2 = 130; R3 = 170; R4 = 200; R5 = 250; R6 = 300;
      } SubTask++; break;
    case 1:
      // initial entry point or after a movement
      if (LedMode != 5) {SetLedMode(5);}
      Status$ = "Scanning"; SubTask = 2; break;
    case 2: // wait for a wall to appear and if necessary change direction
      // only move onto SubTask 3 when a wall appears
      if (LedMode != 5) {SetLedMode(5);}
      if ((Range >= R0) && (Range <= R3)) {
        Status$ = "Backaway";
        SubTask = 3; Drive = abs(Drive);
        if (Drive != 3) {
          // change drive direction from forwards to backwards
          Drive = 3;
        }
      } else if ((Range >= R4) && (Range <= RM)) {
        Status$ = "Tracking";
        SubTask = 3; Drive= abs(Drive);
        if (Drive != 1) {
          // change drive direction from backards to forwards
          Drive = 1;
        }
      } break;
    case 3: // scan for wall and respond
      if (LedMode != 5) {SetLedMode(5);}
      if (Range >= R0) {
        if (Range > RM) {
          // target moved out of range so stop
          Status$ = "Target Lost";
          PWM_FL = 0; PWM_FR = 0; PWM_RL = 0; PWM_RR = 0;
          SubTask = 4;
        } else if ((zMode > 0) && (Range > R6)) {
          // target tracking mode
          // if driving forward let it continue, but if not start moderately
          Status$ = "Target >= R6";
          Drive = 1;  // set Drive as forward
          DrivePWM = map(Range,R6,RM,PwmFwdMax,PWM_StartMin);
          PWM_FL = DrivePWM; PWM_FR = DrivePWM; PWM_RL = DrivePWM; PWM_RR = DrivePWM;
        } else if ((zMode > 0) && (Range >= R4) && (Range <= R6)) {
          // far wall detected so drive speed depends on how close it is
          Status$ = "Target >= R4";
          DrivePWM = map(Range, R4,R5,PWM_StartMin,PwmFwdMax);
          if (Range >= R5) {DrivePWM = PwmFwdMax;} // cap max forward drive value
//          GetSteeringDrive(1);
          PWM_FL = DrivePWM; PWM_FR = DrivePWM; PWM_RL = DrivePWM; PWM_RR = DrivePWM;
          Drive = 1;
        } else if ((zMode > 0) && (Range < R4) && (Range > R3)) {
          // in mode 1 centre deadband
          Status$ = "Centre Deadband";
          PWM_FL = 0; PWM_FR = 0; PWM_RL = 0; PWM_RR = 0; Drive = 0;
        } else if ((Range <= R3) && (Range >= R1)) {
          // in either mode a close wall is detected so backaway speed
          // depends on how close it is
          Status$ = "Target <= R3";
          DrivePWM = map(Range,R3,R2,PWM_StartMin,PwmBckMax);
          if (Range <= R2) {Status$ = "Target <= R2"; DrivePWM = PwmBckMax;} // cap max drive value
//          GetSteeringDrive(-1);
          PWM_FL = -DrivePWM; PWM_FR = -DrivePWM; PWM_RL = -DrivePWM; PWM_RR = -DrivePWM;
          Drive = 3;
        } else if (Range < R1) {
          // in either mode a very close wall detected so slow down backaway speed
          Status$ = "Target < R1";
          DrivePWM = map(Range, R0,R1,PWM_StartMin,PwmBckMax);
//          GetSteeringDrive(-1);
          PWM_FL = -DrivePWM; PWM_FR = -DrivePWM; PWM_RL = -DrivePWM; PWM_RR = -DrivePWM;
          Drive = 3;
        } else {
          // in centre deadband so stop
          PWM_FL = 0; PWM_FR = 0; PWM_RL = 0; PWM_RR = 0; Drive = 0;
          SubTask = 4;
        }
      } else {
        // no wall detected but one had been previously
        SubTask = 4;
      } break;
    case 4: // stop moving and wait
      Status$ = "Stop"; Drive = -abs(Drive);
      PWM_FL = 0; PWM_FR = 0; PWM_RL = 0; PWM_RR = 0; Drive = 0;
      SubTask++; anyMilli = millis(); break;  // start timer for pause period
    case 5: // wait for a valid range then return to previous movement
      if (LedMode != 5) {SetLedMode(5);}
      if ((Range >= R0) && (Range <= R3)) {
        // valid reverse range
        if (Drive == -3) {
          // previously driving backwards
          TgtCnt = 1; SubTask = 3;
        } else {SubTask = 2;} // driving direction changing
      } else if ((zMode > 0) && (Range >= R4) && (Range <= RM)) {
        // valid forward range
        if (Drive == -1) {
          // previously driving forwards so continue
          TgtCnt = 1; SubTask = 3;
        } else {SubTask = 2;} // driving direction changing
      }
      if (zMode == 0) {
        // zMode = 0 back away from an approaching target
        // check after a delay to see if a return movement is needed
        if ((millis() - anyMilli) >= 5000) {
          if (IntP36Cnt < -2) {SubTask++;} // at least half a wheel turn backwards
          else {anyMilli = millis();}
        }
      } else if (zMode == 1) {
        // zMode = 1 maintains a fixed distance from target
        // if stood still after a delay return to ready state
        if ((millis() - anyMilli) >= 5000) {
          anyMilli = millis(); SubTask = 2;
        }
      }
      break;
    case 6:
      // prepare for return to start movement
      DrivePWM = PWM_StartMax; Drive = 0; SubTask++; break;
    case 7:
      // change direction of drive movement to forward
      SetLedMode(21); Drive = 1; SubTask++; break;
    case 8: 
      // check reached beginning or seen another wall?
//      Serial.println("Driven = " + String(IntP36Cnt));
      if (((Range >= R0) && (Range <= R3)) || ((IntP34Cnt + IntP36Cnt) >= 0)) {
        // stop driving forward
        Status$ = "Stopping"; Drive = 0;
        PWM_FL = 0; PWM_FR = 0; PWM_RL = 0; PWM_RR = 0; Drive = 0;
        if ((IntP34Cnt + IntP36Cnt) >= 0) {Reset_Slots();}
        SubTask = 1; SetLedMode(5);
      } else {
        // continue driving forwards, back to start point
        // if approaching start point slow down
        Status$ = "Return To Start";
        if (IntP36Cnt > -120) {if (DrivePWM > PWM_StartMax) {DrivePWM -= 2;}} // slow down
        else if (DrivePWM < PwmFwdMax) {DrivePWM += 1;} // slowly speed up towards start point
        PWM_FL = DrivePWM; PWM_FR = DrivePWM; PWM_RL = DrivePWM; PWM_RR = DrivePWM;
      } break;
  } MainRun = false;
}

// --------------------------------------------------------------------------------

void MotorDriveTask() {
  // called at 60Hz from the main task loop to control motor PWMs and dither
  // control variables are set through the Motor(,,,) function
  // Generate dither signal automatically, note h/w PWM is 30kHz
//  Dither = -Dither; // alternating 30Hz signal
  Dither = -Dither;
  DithON = false;   // clear the applied flag
  
  // now create PWM counter signals
  // front left wheel motor
  int16_t zPWM = PWM_FL; int16_t zStart = PWM_Start + 25;
  if (zPWM >  0) {
    if (zPWM < zStart) {zPWM += Dither; zPWM = constrain(zPWM,0,255); DithON = true;}
    ledcWrite(PwmChFntLftA, 255 - zPWM); ledcWrite(PwmChFntLftB, 255); DIR_FL = 1;
  } else if (
    PWM_FL == 0) {ledcWrite(PwmChFntLftA, 0); ledcWrite(PwmChFntLftB, 0); DIR_FL = 0;
  } else {
    if (zPWM > -zStart) {zPWM += Dither; zPWM = constrain(zPWM,-255,0); DithON = true;}
    ledcWrite(PwmChFntLftA, 255); ledcWrite(PwmChFntLftB, 255 + zPWM); DIR_FL = -1;
  }
  
  // front right wheel motor
  zPWM = PWM_FR; 
  if (zPWM >  0) {
    if (zPWM < zStart) {zPWM += Dither; zPWM = constrain(zPWM,0,255); DithON = true;}
    ledcWrite(PwmChFntRhtA, 255); ledcWrite(PwmChFntRhtB, 255 - zPWM); DIR_FR = 1;
  } else if (PWM_FR == 0) {
    ledcWrite(PwmChFntRhtA, 0); ledcWrite(PwmChFntRhtB, 0); DIR_FR = 0;
  } else {
    if (zPWM > -zStart) {zPWM += Dither; zPWM = constrain(zPWM,-255,0); DithON = true;}
    ledcWrite(PwmChFntRhtA, 255 + zPWM); ledcWrite(PwmChFntRhtB, 255); DIR_FR = -1;
  }

  // rear left wheel motor
  zPWM = PWM_RL; 
  if (zPWM >  0) {
    if (zPWM < zStart) {zPWM += Dither; zPWM = constrain(zPWM,0,255); DithON = true;}
    ledcWrite(PwmChBckLftA, 255 - zPWM); ledcWrite(PwmChBckLftB, 255); DIR_RL = 1;
  } else if (PWM_RL == 0) {ledcWrite(PwmChBckLftA, 0); ledcWrite(PwmChBckLftB, 0); DIR_RL = 0;}
  else {
    if (zPWM > -zStart) {zPWM += Dither; zPWM = constrain(zPWM,-255,0); DithON = true;}
    ledcWrite(PwmChBckLftA, 255); ledcWrite(PwmChBckLftB, 255 + zPWM); DIR_RL = -1;
  }
  
  // rear right wheel motor
  zPWM = PWM_RR; 
  if (zPWM >  0) {
    if (zPWM < zStart) {zPWM += Dither; zPWM = constrain(zPWM,0,255); DithON = true;}
    ledcWrite(PwmChBckRhtA, 255); ledcWrite(PwmChBckRhtB, 255 - zPWM); DIR_RR = 1;
  } else if (PWM_RR == 0) {ledcWrite(PwmChBckRhtA, 0); ledcWrite(PwmChBckRhtB, 0); DIR_RR = 0;}
  else {
    if (zPWM > -zStart) {zPWM += Dither; zPWM = constrain(zPWM,-255,0); DithON = true;}
    ledcWrite(PwmChBckRhtA, 255 + zPWM); ledcWrite(PwmChBckRhtB, 255); DIR_RR = -1;
  }
}

// --------------------------------------------------------------------------------

void Pixy_Servo_Test() {
  // moves both servos over s small range to show they are working over I2C
  if (ServoInc < 1) {
    ServoVal-= 5;
    if (ServoVal <= 200) {ServoInc = 1;}
    else {pixy.setLED(((ServoVal - 200) * 255)/(700 - 200),0,0);}
  } else {
    ServoVal+= 5;
    if (ServoVal >= 700) {ServoInc = -1;}
    else {pixy.setLED(0,((ServoVal - 200) * 255)/(700 - 200),0);}
  }
  pixy.setServos(ServoVal,ServoVal);  // set both servos to the same value
//  uint8_t zFps = pixy.getFPS();
}

// --------------------------------------------------------------------------------

void PWM_Test() {
  // performs a simple PWM test on all channels, using PwmBckLftA
  if (digitalRead(sw1Pin) == LOW) {
    // set start conditions
    PwmEn = true; Inc = 1; TEST_PWM = 0;
    MotorPWM (0,0,0,0);
  }
  if (digitalRead(sw0Pin) == LOW) {
    // stop current PWM
    PwmEn = false; MotorPWM (0,0,0,0); TEST_PWM = 0;
  }
  if (!PwmEn) {return;}
  
  if (Inc < 1) {
    TEST_PWM--;
    if (TEST_PWM <= -128) {Inc = 1;}
  } else {
    TEST_PWM++;
    if (TEST_PWM >= 128) {Inc = -1;}
  }
  MotorPWM (TEST_PWM,TEST_PWM,-TEST_PWM,-TEST_PWM);
//  Serial.println("PWM = " + String(TEST_PWM));
}

// --------------------------------------------------------------------------------

void RGB_Test() {
  // performs a simple colour cycle through all 13 LEDs
  // if button switches are pressed then blank out that side of LEDs
  // skip cycles
  LED_Cnt--; if (LED_Cnt > 0) {return;}
  
  // start by rotating the memory array LM0[]
  for (int zP = NumLEDs - 1; zP > 0; zP--) {LM0[zP] = LM0[zP-1];}
  // now change the colour
  switch(LEDVal) {
    case  0: LM0[0].setRGB(128,  0,  0); break;
    case  1: LM0[0].setRGB( 64, 64,  0); break;
    case  2: LM0[0].setRGB(  0,128,  0); break;
    case  3: LM0[0].setRGB(  0, 64, 64); break;
    case  4: LM0[0].setRGB(  0,  0,128); break;
    case  5: LM0[0].setRGB( 64,  0, 64); break;
  }
  LEDVal++; if (LEDVal > 5) {LEDVal = 0;}
  
  // copy memory bank 0 to o/p
  int zI;
  for (zI = 0; zI < 14; zI++) {LED[zI] = LM0[zI];}
  
  // check button switches
  if (digitalRead(sw0Pin) == LOW) {
    for (zI = 0; zI < 4; zI++) {LED[zI].setRGB(  0,  0,128);}
  }
  if (digitalRead(sw1Pin) == LOW) {
    for (zI = 4; zI < 8; zI++) {LED[zI].setRGB(  0,  0,128);}
  }
  LED_Cnt = 5; FastLED.show();
}

// --------------------------------------------------------------------------------
